> ## Documentation Index
> Fetch the complete documentation index at: https://help.teable.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Grant one of my credentials to a resource

> Only the credential owner can grant it, and only to resources they can edit. An alias already bound on the resource is replaced only with `replace: true`.



## OpenAPI

````yaml /swagger.json post /credential/grant
openapi: 3.0.0
info:
  version: 1.0.0
  title: Teable App
  description: Manage Data as easy as drink a cup of tea
  x-logo:
    backgroundColor: '#F0F0F0'
    altText: Teable logo
servers:
  - url: https://app.teable.ai/api
security: []
tags:
  - name: base
    x-group: project
  - name: base node
    x-group: project node
  - name: base-share
    x-group: project-share
paths:
  /credential/grant:
    post:
      tags:
        - credential
      summary: Grant one of my credentials to a resource
      description: >-
        Only the credential owner can grant it, and only to resources they can
        edit. An alias already bound on the resource is replaced only with
        `replace: true`.
      requestBody:
        content:
          application/json:
            schema:
              type: object
              properties:
                resourceType:
                  type: string
                  enum:
                    - automation
                    - app
                resourceId:
                  type: string
                  minLength: 1
                alias:
                  type: string
                  pattern: ^[A-Z][A-Z0-9_]{0,63}$
                replace:
                  type: boolean
                credentialType:
                  type: string
                  enum:
                    - secret
                    - connection
                credentialId:
                  type: string
                  minLength: 1
              required:
                - resourceType
                - resourceId
                - credentialType
                - credentialId
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                type: object
                properties:
                  id:
                    type: string
                  credentialType:
                    type: string
                    enum:
                      - secret
                      - connection
                  credentialId:
                    type: string
                  alias:
                    type: string
                  resourceType:
                    type: string
                    enum:
                      - automation
                      - app
                  resourceId:
                    type: string
                  baseId:
                    type: string
                  owner:
                    type: object
                    properties:
                      id:
                        type: string
                      name:
                        type: string
                      avatar:
                        type: string
                        nullable: true
                      inSpace:
                        type: boolean
                      isMe:
                        type: boolean
                    required:
                      - id
                      - name
                      - avatar
                      - inSpace
                      - isMe
                  credential:
                    type: object
                    properties:
                      name:
                        type: string
                      key:
                        type: string
                      provider:
                        type: string
                      source:
                        type: string
                        enum:
                          - native
                          - composio
                      account:
                        type: string
                        nullable: true
                      description:
                        type: string
                        nullable: true
                      missing:
                        type: boolean
                    required:
                      - name
                      - missing
                  createdTime:
                    type: string
                required:
                  - id
                  - credentialType
                  - credentialId
                  - alias
                  - resourceType
                  - resourceId
                  - baseId
                  - owner
                  - credential
                  - createdTime
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: Shell
          source: |-
            curl --request POST \
              --url https://app.teable.ai/api/credential/grant \
              --header 'Authorization: Bearer REPLACE_BEARER_TOKEN' \
              --header 'content-type: application/json' \
              --data '{"resourceType":"automation","resourceId":"string","alias":"string","replace":true,"credentialType":"secret","credentialId":"string"}'
        - lang: JavaScript
          source: |-
            const url = 'https://app.teable.ai/api/credential/grant';
            const options = {
              method: 'POST',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              },
              body: '{"resourceType":"automation","resourceId":"string","alias":"string","replace":true,"credentialType":"secret","credentialId":"string"}'
            };

            try {
              const response = await fetch(url, options);
              const data = await response.json();
              console.log(data);
            } catch (error) {
              console.error(error);
            }
        - lang: Node.js
          source: |-
            const http = require('https');

            const options = {
              method: 'POST',
              hostname: 'app.teable.ai',
              port: null,
              path: '/api/credential/grant',
              headers: {
                Authorization: 'Bearer REPLACE_BEARER_TOKEN',
                'content-type': 'application/json'
              }
            };

            const req = http.request(options, function (res) {
              const chunks = [];

              res.on('data', function (chunk) {
                chunks.push(chunk);
              });

              res.on('end', function () {
                const body = Buffer.concat(chunks);
                console.log(body.toString());
              });
            });

            req.write(JSON.stringify({
              resourceType: 'automation',
              resourceId: 'string',
              alias: 'string',
              replace: true,
              credentialType: 'secret',
              credentialId: 'string'
            }));
            req.end();
        - lang: Python
          source: >-
            import http.client


            conn = http.client.HTTPSConnection("app.teable.ai")


            payload =
            "{\"resourceType\":\"automation\",\"resourceId\":\"string\",\"alias\":\"string\",\"replace\":true,\"credentialType\":\"secret\",\"credentialId\":\"string\"}"


            headers = {
                'Authorization': "Bearer REPLACE_BEARER_TOKEN",
                'content-type': "application/json"
            }


            conn.request("POST", "/api/credential/grant", payload, headers)


            res = conn.getresponse()

            data = res.read()


            print(data.decode("utf-8"))
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer

````